# -*- coding: utf-8 -*-

import os
import commands

import dbus

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyKDE4.plasma import Plasma
from PyKDE4 import plasmascript
from PyKDE4.kdeui import KIcon, KIconLoader
from PyKDE4.kdecore import i18n

ICONPATH = None

def pixmapFromSVG(name, size):
        svg = Plasma.Svg()
        svg.setImagePath(ICONPATH + os.sep + name)
        svg.setContainsMultipleImages(False)
	svg.resize(size.width(), size.height())
        return svg.pixmap()

class ROSAStarterPlasmoid(plasmascript.Applet):
    def __init__(self, parent, args = None):
        super(ROSAStarterPlasmoid, self).__init__(parent)

    def init(self):

	# DBus init
	#self.dbus_object = None
	#self.dbus_object = None
	self.timer = QTimer(self.applet)
	self.timer.timeout.connect(self.prepareLauncher)
        self.timer.setSingleShot(True)
	self.timer.start(1000)
	
        self.setHasConfigurationInterface(False)
        self.setAspectRatioMode(Plasma.Square)
        self.theme = Plasma.Svg(self)
        self.iconpath = unicode(self.package().path() + 'contents/icons/');
        checkerpath = unicode(self.package().path() + 'contents/code/checkos.sh');
	global ICONPATH
	ICONPATH = self.iconpath

	self.layout = QGraphicsLinearLayout(Qt.Vertical, self.applet)
	#self.layout.setContentsMargins(0, 0, 0, 0)
	self.layout.setContentsMargins(0, 4, 0, 5)
        self.setMinimumWidth(10)
        self.setMinimumHeight(10)

        # Size forcing
        #self.geometryChanged.connect(self.resetIconSize)
        
	# Install icon
	out = commands.getstatusoutput("xdg-icon-resource install --size 48 " + self.iconpath + "/rosa-icon.png rosa-starter")
	if out[0] == 0:
	    print ("rosastarter icon installed").encode('utf-8')
	else:
	    print ("Error installing rosastarter icon: ").encode('utf-8'), out


        panelRect = self.applet.topLevelWidget().screenRect()
	self.icon_size = 48
        if(self.formFactor() == Plasma.Vertical):
	    self.icon_size = panelRect.width()
	elif(self.formFactor() == Plasma.Horizontal):
	    self.icon_size = panelRect.height()
	self.resize(self.icon_size, self.icon_size)

	#self.icon = Plasma.IconWidget(QIcon(pixmapFromSVG("rosa-red.svg", QSize(self.icon_size, self.icon_size))), "", self.applet)

        ## Rebrending part
        if(os.system(checkerpath) / 256 == 0):
                self.icon = Plasma.IconWidget(QIcon(ICONPATH + os.sep + "rosa-icon.png"), "", self.applet)
        else:
                self.icon = Plasma.IconWidget(QIcon(ICONPATH + os.sep + "mandriva-icon.png"), "", self.applet)

	self.layout.addItem(self.icon)
        #self.geometryChanged.connect(self.icon.update)
        self.geometryChanged.connect(self.resetIconSize)

	self.icon.clicked.connect(self.buttonClicked)

        # Tooltip
        # Tooltip disabled for better usability
        #toolTipData = Plasma.ToolTipContent()

        #toolTipData.setMainText(i18n("SimpleWelcome"))
        #toolTipData.setSubText(i18n("Application launcher"))
        #toolTipData.setImage(self.icon.icon().pixmap(32, 32))

        #Plasma.ToolTipManager.self().setContent(self.applet, toolTipData)

        #self.setCacheMode(Qt.NoCache)

    def resetIconSize(self):
        #self.icon.resize(self.size())
        self.icon.update(self.icon.boundingRect())
        
    def prepareLauncher(self):
	# DBus init
	try:
	    dbus_object = dbus.SessionBus().get_object('org.kde.ROSA_Launcher', '/MainApplication')
	    dbus_interface = dbus.Interface(dbus_object, dbus_interface='org.kde.ROSA_Launcher')
	except dbus.exceptions.DBusException:
	    os.system('rosa-launcher -s')

    @pyqtSlot(name="toolTipAboutToShow")
    def toolTipAboutToShow(self):
        pass 
        
    def keyPressEvent(self, event):
        pass

    def buttonClicked(self):
        os.system('rosa-launcher')
	#if(self.dbus_interface):
	#    self.dbus_interface.toggle()
	    

def CreateApplet(parent):
    return ROSAStarterPlasmoid(parent)
